<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="所属角色" prop="roleId">
        <el-select v-model="queryParams.roleId" placeholder="请选择所属角色" clearable size="small">
          <el-option
                v-for="item in roles"
                :key="item.roleId"
                :label="item.roleName"
                :value="item.roleId"
              />
        </el-select>
      </el-form-item>
      <el-form-item label="知识库" prop="datasetName">
        <el-input
          v-model="queryParams.datasetName"
          placeholder="请输入知识库名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['chat:chatDataset:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['chat:chatDataset:edit']"
        >修改</el-button>
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['chat:chatDataset:remove']"
        >删除</el-button>
      </el-col> -->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table border v-loading="loading" :data="chatDatasetList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="datasetId" />
      <el-table-column label="所属角色" align="center" prop="roleName" />
      <el-table-column label="知识库名称" align="center" prop="datasetName" />
      <el-table-column label="ExtId" align="center" prop="extId" />
      <el-table-column label="创建时间" align="center" prop="createTime" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleFile(scope.row)"
            v-hasPermi="['chat:chatDataset:file']"
          >文件管理</el-button>
          <!-- <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['chat:chatDataset:remove']"
          >删除</el-button> -->
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改知识库对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="所属角色" prop="roleId"  >
          <el-select v-model="form.roleId"  placeholder="请选择所属角色" clearable size="small">
            <el-option
                  v-for="item in roles"
                  :key="item.roleId"
                  :label="item.roleName"
                  :value="item.roleId"
                />
          </el-select>
        </el-form-item>
        <el-form-item label="知识库名称" prop="datasetName">
          <el-input v-model="form.datasetName" placeholder="请输入名称" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <el-drawer
            :with-header="false"
            size="75%"
             title="文件管理" :visible.sync="file.open">
         <chatDatasetFile  ref="chatDatasetFile" />
    </el-drawer>
  </div>
</template>

<script>
import { listChatDataset, getChatDataset, delChatDataset, addChatDataset, updateChatDataset, exportChatDataset } from "@/api/chat/chatDataset";
import { getAllRoleList } from "@/api/chat/chatRole";
import chatDatasetFile from "@/views/chat/components/chatDatasetFile.vue";
export default {
  name: "ChatDataset",
  components:{chatDatasetFile},
  data() {
    return {
      file:{
        open:false,
      },
      roles:[],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 知识库表格数据
      chatDatasetList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        roleId: null,
        datasetName: null,
        extId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        roleId: [
          { required: true, message: "所属角色不能为空", trigger: "blur" }
        ],
        datasetName: [
          { required: true, message: "知识库名称不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    getAllRoleList().then(response => {
        this.roles = response.data;
    });
    this.getList();
  },
  methods: {
    handleFile(row){
      this.file.open=true;
      setTimeout(() => {
             this.$refs.chatDatasetFile.getFiles(row);
        }, 200);
    },
    /** 查询知识库列表 */
    getList() {
      this.loading = true;
      listChatDataset(this.queryParams).then(response => {
        this.chatDatasetList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        datasetId: null,
        roleId: null,
        datasetName: null,
        extId: null,
        createTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.datasetId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加知识库";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const datasetId = row.datasetId || this.ids
      getChatDataset(datasetId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改知识库";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.datasetId != null) {
            updateChatDataset(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addChatDataset(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const datasetIds = row.datasetId || this.ids;
      this.$confirm('是否确认删除知识库编号为"' + datasetIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delChatDataset(datasetIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有知识库数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportChatDataset(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
